<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleChargeTypeTaxAmount1 ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleChargeTypeTaxAmount1 extends AbstractStructArrayBase
{
    /**
     * The TaxAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleChargeTypeTaxAmount[]
     */
    public $TaxAmount;
    /**
     * Constructor method for ArrayOfVehicleChargeTypeTaxAmount1
     * @uses DgArrayOfVehicleChargeTypeTaxAmount1::setTaxAmount()
     * @param \dgsoft\StructType\DgVehicleChargeTypeTaxAmount[] $taxAmount
     */
    public function __construct(array $taxAmount = array())
    {
        $this
            ->setTaxAmount($taxAmount);
    }
    /**
     * Get TaxAmount value
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount[]|null
     */
    public function getTaxAmount()
    {
        return $this->TaxAmount;
    }
    /**
     * Set TaxAmount value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleChargeTypeTaxAmount[] $taxAmount
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargeTypeTaxAmount1
     */
    public function setTaxAmount(array $taxAmount = array())
    {
        foreach ($taxAmount as $arrayOfVehicleChargeTypeTaxAmount1TaxAmountItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleChargeTypeTaxAmount1TaxAmountItem instanceof \dgsoft\StructType\DgVehicleChargeTypeTaxAmount) {
                throw new \InvalidArgumentException(sprintf('The TaxAmount property can only contain items of \dgsoft\StructType\DgVehicleChargeTypeTaxAmount, "%s" given', is_object($arrayOfVehicleChargeTypeTaxAmount1TaxAmountItem) ? get_class($arrayOfVehicleChargeTypeTaxAmount1TaxAmountItem) : gettype($arrayOfVehicleChargeTypeTaxAmount1TaxAmountItem)), __LINE__);
            }
        }
        $this->TaxAmount = $taxAmount;
        return $this;
    }
    /**
     * Add item to TaxAmount value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleChargeTypeTaxAmount $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargeTypeTaxAmount1
     */
    public function addToTaxAmount(\dgsoft\StructType\DgVehicleChargeTypeTaxAmount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleChargeTypeTaxAmount) {
            throw new \InvalidArgumentException(sprintf('The TaxAmount property can only contain items of \dgsoft\StructType\DgVehicleChargeTypeTaxAmount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TaxAmount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleChargeTypeTaxAmount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TaxAmount
     */
    public function getAttributeName()
    {
        return 'TaxAmount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargeTypeTaxAmount1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
